#include "juego.h"

using namespace STDP;

void Juego::iniciarJuego(int modo){ // modo es el tipo de partida seleccionada desde el menu principal
	bool findeljuego = 0;
	crearTableros();
	mostrarCuentaAtras();
	do{
		tableroActual = 1;
		bonusActual=tiempoInicial+(nivelActual-1)*incrementoTiempo; //Fórmula para calcular el bonus del nivel
		if(borrarBonus==true){
			bonusActual=0;
			borrarBonus=false;
		}
		mostrarDatosJuego();
		mostrarBonus();
		mostrarPuntuacion();
		mostrarTablero();

		findeljuego=controlPersonaje();

		if(findeljuego==false){
			findeljuego=pantallaFinNivel();
			nivelActual++;
			puntuacionPartida+=bonusActual;
			crearTableros();
			numeroCocos=471;
			for(int i = 0; i<8; i++){
				muerteEnemigos[i][0]=1;
				muerteEnemigos[i][1]=0;
			}
			if(nivelActual>7)
				radioPersecucion++;
		}
		else if(findeljuego== true && vidas!=0){
			findeljuego=false;
			vidas--;
			borrarBonus=true;
			for(int i = 0; i<8; i++){
				muerteEnemigos[i][0]=1;
				muerteEnemigos[i][1]=0;
			}
		}

	}while(findeljuego==false);
}

void Juego::mostrarCuentaAtras(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(36,11);
	stdp.writeStr("Ready?");
	mostrarPuntuacion();
	stdp.refreshScr();
	sleep(1);
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(33,11);
	stdp.writeStr("Really ready?");
	mostrarPuntuacion();
	mostrarBonus();
	stdp.refreshScr();
	sleep(1);
	mostrarDatosJuego();
	mostrarPuntuacion();
	mostrarBonus();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ABOLD, CGREEN, CBLACK);
	stdp.setCursor(38,11);
	stdp.writeStr("GO!");
	stdp.refreshScr();
	sleep(1);

}

void Juego::mostrarDatosJuego(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(1,0);
	stdp.writeStr("Nivel: ");
	char* nivelConvertido;
	nivelConvertido = new char[3];
	sprintf(nivelConvertido,"%d",nivelActual); //Convertimos el entero a cadena de caracteres
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(nivelConvertido);

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(72,0);
	for(int i =0; i<vidas-1;i++)
		stdp.writeStr("@ ");


}

void Juego::restarBonus(){
	if(bonusActual>0)
		bonusActual--;
	usleep(75000);
}

void Juego::mostrarBonus(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(55,0);
	stdp.writeStr("             ");
	stdp.setCursor(55,0);
	stdp.writeStr("Bonus: ");
	char* bonusConvertido;
	bonusConvertido = new char[8];
	sprintf(bonusConvertido,"%d",bonusActual);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(bonusConvertido);

	stdp.setColor(ABOLD, CCYAN, CBLACK);
	stdp.setCursor(15,0);
	stdp.writeStr("      ");
	stdp.setCursor(15,0);
	stdp.writeStr("&: ");
	char* movimientosSupercocoCovertida;
	movimientosSupercocoCovertida = new char[8];
	sprintf(movimientosSupercocoCovertida,"%d",movimientosSupercoco);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(movimientosSupercocoCovertida);
}

void Juego::mostrarPuntuacion(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(32,0);
	stdp.writeStr("                   ");
	stdp.setCursor(32,0);
	stdp.writeStr("Puntuacion: ");
	char* puntuacionConvertida;
	puntuacionConvertida = new char[8];
	sprintf(puntuacionConvertida,"%d",puntuacionPartida);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(puntuacionConvertida);


}

void Juego::crearTableros(){

	//Inicializa el array
	for(int i=0; i< 80; i++){
		for(int j=1; j< 24; j++){
			tablero[0][i][j]=' ';
			tablero[1][i][j]=' ';
		}
	}
	//Tablero 1

	for(int j=1; j< 24; j++){
		tablero[1][0][j]='|';
		tablero[1][79][j]='|';
	}
	for(int i=0; i< 80; i++){
		tablero[1][i][1]='-';
		tablero[1][i][23]='-';
	}

	for(int j=5; j<20; j++){
		tablero[1][36][j]='|';
		tablero[1][42][j]='|';
		tablero[1][11][j]='|';
		tablero[1][68][j]='|';
	}

	for(int i=11; i<69; i++){
		tablero[1][i][5]='-';
		tablero[1][i][19]='-';
		tablero[1][i][10]='-';
		tablero[1][i][14]='-';
	}

	for(int i= 37; i<42; i++){
		tablero[1][i][5]=' ';
		tablero[1][i][10]=' ';
		tablero[1][i][14]=' ';
		tablero[1][i][19]=' ';
	}
	for(int j= 11; j<14; j++){
		tablero[1][11][j]=' ';
		tablero[1][36][j]=' ';
		tablero[1][42][j]=' ';
		tablero[1][68][j]=' ';

	}
	tablero[1][36][16]=' ';
	tablero[1][36][17]=' ';
	tablero[1][42][16]=' ';
	tablero[1][42][17]=' ';
	for(int i = 36; i<=42; i++){
		tablero[1][i][14] = '-';
		tablero[1][i][17] = '-';
	}
	tablero[1][36][15]=' ';
	tablero[1][42][15]=' ';



	for(int i = 1; i<= 77; i=i+2){
		tablero[1][i][2] = '*';
		tablero[1][i][3] = '*';
		tablero[1][i][4] = '*';
		tablero[1][i][11] = '*';
		tablero[1][i][12] = '*';
		tablero[1][i][13] = '*';
		tablero[1][i][20] = '*';
		tablero[1][i][21] = '*';
		tablero[1][i][22] = '*';
	}

	for(int j = 2; j<= 22; j++){
		tablero[1][1][j] = '*';
		tablero[1][3][j] = '*';
		tablero[1][5][j] = '*';
		tablero[1][7][j] = '*';
		tablero[1][9][j] = '*';
		tablero[1][77][j] = '*';
		tablero[1][75][j] = '*';
		tablero[1][73][j] = '*';
		tablero[1][71][j] = '*';
		tablero[1][69][j] = '*';

	}
	tablero[1][3][21] = '0';
	tablero[1][3][3] = '0';
	tablero[1][75][21] = '0';
	tablero[1][75][3] = '0';


}

void Juego::mostrarTablero(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	for(int i=0; i< 80; i++){
		for(int j=1; j< 24; j++){
			stdp.setCursor(i,j);
			if(tablero[tableroActual][i][j]=='*')
				stdp.setColor(ANORMAL, CYELLOW, CBLACK);
			if(tablero[tableroActual][i][j]=='-' || tablero[tableroActual][i][j]=='|')
				stdp.setColor(ANORMAL, CRED, CBLACK);
			if(tablero[tableroActual][i][j]=='0')
				stdp.setColor(ANORMAL, CGREEN, CBLACK);
			stdp.writeChar(tablero[tableroActual][i][j]);
		}
	}
}

bool Juego::controlPersonaje(){
	bool muerte = 0;
	int j = 0;

	int numeroPulsaciones = 0;
	int numeroMovimientos = 0;

	int teclapulsada=0;
	posicionPersonaje[1]=18;
	posicionPersonaje[0]=39;

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	generarEnemigos();

	do{
		int h;
		int k;
		if(supercoco==true)
			h=1;
		else
			h=2;



		moverTodo=false;
		if(supercoco==true)
				k=2;
			else
				k=1;

		teclapulsada=stdp.getKey();
			if(supercoco==false){
				stdp.setColor(ABOLD,CBLUE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				stdp.writeChar('@');
			}
			else{
				stdp.setColor(ABOLD,CCYAN,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				stdp.writeChar('&');
			}



			if(muerte==false){
				mostrarPuntuacion();
				restarBonus();
				mostrarBonus();

			}

			if(teclapulsada==KESCAPE){
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(22,0);
				stdp.writeStr("*PAUSA*");
				do{
				}while(stdp.getKey()!=KESCAPE);
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(22,0);
				stdp.writeStr("       ");
			}

			if(muerte==false){
				//Control de las teclas con el comecocos
				if(teclapulsada==KRIGHT && (tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]] != '|' && tablero[tableroActual][posicionPersonaje[0]+1][posicionPersonaje[1]] != '|' && tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[0]+=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KLEFT && (tablero[tableroActual][posicionPersonaje[0]-1][posicionPersonaje[1]]!= '|' && tablero[tableroActual][posicionPersonaje[0]-2][posicionPersonaje[1]]!= '|' && tablero[tableroActual][posicionPersonaje[0]-2][posicionPersonaje[1]] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[0]-=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KUP && (tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]-1]!= '|' && tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]-1] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]--;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KDOWN && (tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]+1]!= '|' && tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]+1] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]++;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KUR && (tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]!= '|' && tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1]!= '-' && tablero[tableroActual][posicionPersonaje[0]+1][posicionPersonaje[1]-1]!= '|' && tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]-1] && tablero[tableroActual][posicionPersonaje[0]+1][posicionPersonaje[1]-1]!= '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]--;
					posicionPersonaje[0]+=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
				}
				else if(teclapulsada==KUL && (tablero[tableroActual][posicionPersonaje[0]-1][posicionPersonaje[1]-1]!= '|' && tablero[tableroActual][posicionPersonaje[0]-2][posicionPersonaje[1]-1]!= '|' && tablero[tableroActual][posicionPersonaje[0]-1][posicionPersonaje[1]-1] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]--;
					posicionPersonaje[0]-=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KDR && (tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1]!= '|' && tablero[tableroActual][posicionPersonaje[0]+1][posicionPersonaje[1]+1]!= '|' && tablero[tableroActual][posicionPersonaje[0]+2][posicionPersonaje[1]+1] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]++;
					posicionPersonaje[0]+=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				else if(teclapulsada==KDL && (tablero[tableroActual][posicionPersonaje[0]-1][posicionPersonaje[1]+1]!= '|' && tablero[tableroActual][posicionPersonaje[0]-2][posicionPersonaje[1]+1]!= '|' && tablero[tableroActual][posicionPersonaje[0]-1][posicionPersonaje[1]+1] != '-')){
					moverTodo=true;
					stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
					stdp.writeChar(' ');
					posicionPersonaje[1]++;
					posicionPersonaje[0]-=2;
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '*'){
						puntuacionPartida+=10;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
					}
					if(tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] == '0'){
						puntuacionPartida+=50;
						numeroCocos--;
						tablero[tableroActual][posicionPersonaje[0]][posicionPersonaje[1]] = ' ';
						supercoco=true;
						tiempoSupercoco=4;
						movimientosSupercoco=50;
					}
					if(supercoco==true)
						movimientosSupercoco--;
				}
				if(movimientosSupercoco==0)
					supercoco=false;
			}

			for(h;h>0 && muerte == false;h--){
				controlEnemigos(h,muerte);
			}


	}while(numeroCocos > 0 && muerte == false);
	if(muerte==true){

		mostrarTablero();

		for(int j = 0; j<5; j++){
			stdp.setColor(ABOLD,CWHITE,CBLACK);
			stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
			stdp.writeChar('w');
			stdp.refreshScr();
			usleep(100000);
			stdp.setColor(ABOLD,CBLUE,CBLACK);
			stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
			stdp.writeChar('@');
			stdp.refreshScr();
			usleep(100000);
			stdp.setCursor(0,0);
			stdp.writeChar(' ');
			cout << "\a";
		}

		stdp.setColor(ABOLD,CGREEN,CBLACK);
		stdp.setCursor(53,7);
		stdp.writeStr("Pulsa");
		stdp.setCursor(52,8);
		stdp.writeStr("Espacio");
		if(vidas==0){
			stdp.setColor(ABOLD,CRED,CBLACK);
			stdp.setCursor(21,7);
			stdp.writeStr("FIN");
		}
		do{
		}while(stdp.getKey()!=KSPACE);

	}
	return(muerte);
}

void Juego::controlEnemigos(int h,bool &muerte){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	mostrarTablero();
	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(muerteEnemigos[i][1]==0){
			stdp.setColor(ABOLD,CWHITE,CBLACK);
			stdp.setCursor(posicionEnemigos[i][0],posicionEnemigos[i][1]);
			stdp.writeChar('w');
		}

	}



	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(moverTodo == true && tiempoSupercoco==0){
			if(muerteEnemigos[i][0]==1){
				muerteEnemigos[i][1]--;
			}

			else{
				if(abs(abs(posicionEnemigos[i][0] - posicionPersonaje[0])+(abs(posicionEnemigos[i][1] - posicionPersonaje[1])/2)) < radioPersecucion){
					direccionEnemigos[i][0]=posicionPersonaje[0];
					direccionEnemigos[i][1]=posicionPersonaje[1];
				}

				else{
					if(posicionEnemigos[i][0] == direccionEnemigos[i][0] && posicionEnemigos[i][1] == direccionEnemigos[i][1]){
						direccionEnemigos[i][1]= rand() % 21 + 2;
							if(rand() % 2 == 0)
								do{
								direccionEnemigos[i][0]= rand() % 5 + 3;
								}while(direccionEnemigos[i][0] % 2 == 0);
							else if(rand() % 2 == 1)
								do{
								direccionEnemigos[i][0]= rand() % 5 + 71;
								}while(direccionEnemigos[i][0] % 2 == 0);
					}
				}


				//Objetivo a la esquina superior izquierda
				if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) > 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])>0){
					//Se mueve en diagonal
					if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
						posicionEnemigos[i][0]-=2;
					}
				//O a la Izquierda
					else if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]-=2;
					}
				//O hacia arriba
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
				//O hacia abajo
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
				}

				//Si el objetivo está arriba a la derecha
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) > 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])<0){
					//Se mueve en diagonal
					if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1]!= '-' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]-1] && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]-1]!= '-')){
						posicionEnemigos[i][1]--;
						posicionEnemigos[i][0]+=2;
					}
				//O a la derecha
					else if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]+=2;
					}
				//O hacia arriba
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
				//O hacia abajo
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
				}

				//Si el objetivo está abajo a la izquierda
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) < 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])>0){
					//Se mueve en diagonal
					if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
						posicionEnemigos[i][0]-=2;
					}
					//O a la Izquierda
					else if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]-=2;
					}
					//O hacia abajo
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
					//O hacia arriba
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
				}

				//Si el objetivo está abajo a la derecha
				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) < 0 && (posicionEnemigos[i][0] - direccionEnemigos[i][0])<0){
					//Se mueve en diagonal
					if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
						posicionEnemigos[i][0]+=2;
					}
					//O a la derecha
					else if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]+=2;
					}
					//O hacia abajo
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
					//O hacia arriba
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
				}
				else if((posicionEnemigos[i][0] - direccionEnemigos[i][0]) == 0 ){

					if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '-')){
					posicionEnemigos[i][0]-=2;

					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]+=2;
					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
				}

				else if((posicionEnemigos[i][1] - direccionEnemigos[i][1]) == 0 ){

					if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]-1] != '-')){
						posicionEnemigos[i][1]--;
					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]][posicionEnemigos[i][1]+1] != '-')){
						posicionEnemigos[i][1]++;
					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]-1][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]]!= '|' && tablero[tableroActual][posicionEnemigos[i][0]-2][posicionEnemigos[i][1]] != '-')){
					posicionEnemigos[i][0]-=2;

					}
					else if((tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+1][posicionEnemigos[i][1]] != '|' && tablero[tableroActual][posicionEnemigos[i][0]+2][posicionEnemigos[i][1]] != '-')){
						posicionEnemigos[i][0]+=2;
					}
				}
			}
		}
		else if(tiempoSupercoco!=0)
			tiempoSupercoco--;
		else if(supercoco==true && tiempoSupercoco==0){
			tiempoSupercoco=8;
		}
		if(supercoco == false && posicionEnemigos[i][0] == posicionPersonaje[0] && posicionEnemigos[i][1] == posicionPersonaje[1]){
			muerte=true;
		}
		else if(supercoco == true && posicionEnemigos[i][0] == posicionPersonaje[0] && posicionEnemigos[i][1] == posicionPersonaje[1]){
			muerteEnemigos[i][0]=1;
			muerteEnemigos[i][1]=50;
			puntuacionPartida+=10;
			posicionEnemigos[i][0]=0;
			posicionEnemigos[i][0]=0;
		}
		generarEnemigos();
	}
	stdp.refreshScr();
}

void Juego::generarEnemigos(){
	for(int i = 0; i<nivelActual+1 && i < 8; i++){
		if(muerteEnemigos[i][0]==1 && muerteEnemigos[i][1]==0){
			do{
			posicionEnemigos[i][0]=rand() % 5 + 37;
			posicionEnemigos[i][1]=rand() % 6 + 5;
			}while(posicionEnemigos[i][0] % 2==0);
			for(int j = i; j>=0;j--){
				while(posicionEnemigos[i][0] == posicionEnemigos[j][0] && posicionEnemigos[i][1] == posicionEnemigos[j][1] && i != j){
					do{
						posicionEnemigos[i][0]=rand() % 4 + 37;
						posicionEnemigos[i][1]=rand() % 5 + 5;
					}while(posicionEnemigos[i][0] % 2==0);
				}
			}
			muerteEnemigos[i][0]=0;
		}

	}
}

int Juego::pantallaFinNivel(){
	bool posicion=0;
	int teclapulsada=0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.clearScreen();
	stdp.setColor(AUNDERLINE, CYELLOW, CBLACK);
	stdp.setCursor(33,9);
	stdp.writeStr("¡BIEN HECHO!");
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(34,11);
	stdp.writeStr("¿Seguimos?");

	stdp.setColor(ANORMAL, CGREEN, CBLACK);
	stdp.setCursor(36,13);
	stdp.writeStr("Si");
	stdp.setColor(ANORMAL, CRED, CBLACK);
	stdp.setCursor(40,13);
	stdp.writeStr("No");

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	do{
		teclapulsada=stdp.getKey();
		if(posicion==0){
			stdp.setCursor(35,13);
			stdp.writeChar('*');
			stdp.setCursor(39,13);
			stdp.writeChar(' ');
		}
		else{
			stdp.setCursor(39,13);
			stdp.writeChar('*');
			stdp.setCursor(35,13);
			stdp.writeChar(' ');
		}

		if(teclapulsada==KRIGHT)
			posicion=1;
		if(teclapulsada==KLEFT)
			posicion=0;
		stdp.refreshScr();
	}while(teclapulsada!=KSPACE);

	return(posicion);
}
